Option Explicit
Public DocumentsString, PSIniFileString, WshShell, WshNetwork, objWMIService, AppFolder, AppFolderString, AppINIPathString, AppINIFileString, AppINIFile
Public CubaseVersion, oss, os, objFSO, objFSO2, strComputer, strErrText

Copy_Preferences
set objFSO = Nothing
set objFSO2 = Nothing
Set WshShell = Nothing
err_Check
WScript.Quit

'---------------------------------------
Sub Copy_Preferences
dim CubasePrefsFolder, CubasePrefsFolderString
dim SavePrefsFolder, SavePrefsFolderString, PSIiniFile, CPFString, iniLine
dim CubaseFolderString, CubaseExeString, CubaseRunString, ProgFilesArg, Env_ProgFilesArg
On error resume next
CubasePrefsFolderString = ""
CubaseVersion = ""
Set WshShell = CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objFSO2 = CreateObject("Scripting.FileSystemObject")
DocumentsString = WshShell.SpecialFolders("MyDocuments")
AppINIPathString = DocumentsString
if not objFSO.FolderExists(AppINIPathString) then
	err_PrefFSO AppINIPathString, 0
end if
AppINIFileString = AppINIPathString & "\CubasePrefsPath.ini"
if objFSO.FileExists(AppINIFileString) then
	Set AppINIFile = objFSO.OpenTextFile(AppINIFileString, 1)
else
	err_PrefFSO AppINIFileString, 1
end if
CPFString = ""
Do While AppINIFile.AtEndOfStream = False
	iniLine = Left(Trim(AppINIFile.ReadLine), 18)
	If LCase(iniLine) = "[preferences path]" Then
		CPFString = AppINIFile.ReadLine
		CPFString = Trim(Mid(CPFString, InStr(CPFString, "=") + 1))
		CubaseVersion = Trim(Mid(CPFString, InStrRev(CPFString, "\")))
		Exit do
	end if
Loop
AppINIFile.close
Set WshNetwork = WScript.CreateObject("WScript.Network")
strComputer = "."
Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
Set oss = objWMIService.ExecQuery ("Select * from Win32_OperatingSystem")
for each os in oss
	select case left(os.Version,1)
	case "5"
		CubasePrefsFolderString = "c:\Documents and Settings\" & WshNetwork.UserName & CPFString
	case "6"
		CubasePrefsFolderString = "c:\users\" & WshNetwork.UserName & CPFString
	case else
		err_WinVersion os.Version
	end select
next
Set oss = Nothing
Set objWMIService = Nothing
Set WshNetwork = Nothing
set objFSO = Nothing

'--- Preferences saving ----
Set objFSO = CreateObject("Scripting.FileSystemObject")
if objFSO.FolderExists(CubasePrefsFolderString) then
	CubasePrefsFolder = objFSO.GetFolder(CubasePrefsFolderString)
else
	err_PrefFSO CubasePrefsFolderString, 2
end if
Set objFSO = Nothing
Set objFSO = CreateObject("Scripting.FileSystemObject")
AppFolderString = DocumentsString
if not objFSO.FolderExists(AppFolderString) then
	err_PrefFSO AppFolderString, 0
end if
If objFSO2.FolderExists(AppFolderString & CubaseVersion & "_SavedPrefs") then
	AppFolder = objFSO2.GetFolder(AppFolderString & CubaseVersion & "_SavedPrefs")
else
	AppFolder = objFSO2.CreateFolder(AppFolderString & CubaseVersion & "_SavedPrefs")
end if
objFSO.CopyFolder CubasePrefsFolderString, AppFolderString & CubaseVersion & "_SavedPrefs", true

'--- Cubase executable launching ----
CubaseVersion = right(CubaseVersion, len(CubaseVersion) - 1)
CubaseExeString = left(replace(CubaseVersion, " ", ""),7)  & ".exe"
select case len(CubaseVersion)
case 8
	ProgFilesArg = "%PROGRAMW6432%"
	Env_ProgFilesArg = wshShell.ExpandEnvironmentStrings(ProgFilesArg)
	if (Env_ProgFilesArg = ProgFilesArg) or (Env_ProgFilesArg = "") then
		CubaseFolderString = wshShell.ExpandEnvironmentStrings("%PROGRAMFILES%") & "\Steinberg\" & CubaseVersion & "\"
		if objFSO.FileExists(CubaseFolderString & CubaseExeString) then
			CubaseRunString = chr(34) & CubaseFolderString & CubaseExeString & chr(34)
			WshShell.Run CubaseRunString, 1, false
		else
			err_PrefFSO CubaseRunString, 3
		end if
	else
		CubaseFolderString = wshShell.ExpandEnvironmentStrings("%PROGRAMFILES(x86)%") & "\Steinberg\" & CubaseVersion & "\"
		if objFSO.FileExists(CubaseFolderString & CubaseExeString) then
			CubaseRunString = chr(34) & CubaseFolderString & CubaseExeString & chr(34)
			WshShell.Run CubaseRunString, 1, false
		else
			err_PrefFSO CubaseRunString, 3
		end if
	end if
case 11
	CubaseFolderString = wshShell.ExpandEnvironmentStrings("%PROGRAMFILES%") & "\Steinberg\" & left(CubaseVersion, 8) & "\"
	if objFSO.FileExists(CubaseFolderString & CubaseExeString) then
		CubaseRunString = chr(34) & CubaseFolderString & CubaseExeString & chr(34)
		WshShell.Run CubaseRunString, 1, false
	else
		err_PrefFSO CubaseRunString, 3
	end if
case else
	err_PrefFSO CubaseRunString, 3
end select
end sub

'-------------------------------------------------------------
Sub err_PrefFSO(byVal errFSOString, byVal errFSOObjectType)
select case errFSOObjectType
case 0
	Msgbox "The " & errFSOString & " folder could not be located. Please be sure that the path is a valid one." & vbCrLf & "Application cancelled...", vbCritical, "Folder location error..."
case 1
	Msgbox "The " & errFSOString & " file could not be found. Please, check..." & vbCrLf & "Application cancelled...", vbCritical, "INI file location error"
case 2
	Msgbox "The path : " & errFSOString & " is invalid." & vbCrLf & "Application cancelled...", vbCritical, "Cubase preferences path error"
case 3
	Msgbox "Cubase EXE file not found... : " & errFSOString & vbCrLf & vbCrLf & "Application cancelled...", vbCritical, "Cubase EXE file error..."
end select
set objFSO = Nothing
set objFSO2 = Nothing
Set WshShell = Nothing
WScript.Quit
end sub

'-------------------------------------------------------------
sub err_WinVersion(byVal errOSVersion)
strErrText = "This utility works only under Windows XP or higher (OS version from 5.1 to 6.3). Currently used OS version : " & errOSVersion
MsgBox strErrText, vbExclamation
set objFSO = Nothing
set objFSO2 = Nothing
Set WshShell = Nothing
Set oss = Nothing
Set objWMIService = Nothing
set WshNetwork = Nothing
WScript.Quit
end sub

'-------------------------------------------------------------
Sub err_Check
If err.number <> 0 then
	MsgBox "Error #" & err.Number & vbCrLf & err.Description & vbCrLf & Err.Source, vbCritical, "Runtime error..."
	err.Clear
End if
end sub
